unit NEXGuiMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, NEXLowLevel, NEXTypes, NEXUtils, StdCtrls;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    PlayerFileView: TListView;
    TreeView1: TTreeView;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure DoLog(LogStr : string);
  public
    { Public declarations }
    PlayerFiles : TFileTable;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function SecondsToStr(InDuration : integer) : string;
begin
  if InDuration > 60*60 then
  begin
    Result := IntToStr(InDuration div (60*60)) + ':';
    InDuration := InDuration mod (60 * 60);
  end
  else
    Result := '';

  if (InDuration div 60 < 10) and (Result <> '') then
    Result := Result + '0' + IntToStr(InDuration div 60) + ':'
  else
    Result := Result + IntToStr(InDuration div 60) + ':';
  InDuration := InDuration mod 60;

  if (InDuration < 10) and (Result <> '') then
    Result := Result + '0' + IntToStr(InDuration)
  else
    Result := Result + IntToStr(InDuration);
end;

procedure TForm1.DoLog(LogStr: string);
begin
  Memo1.Lines.Add(LogStr);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  FileLoop    : integer;
  NewItem     : TListItem;
  NumSeconds  : integer;
  Bitrate     : integer;

  TmpBuf      : array[0..$210-1] of byte;
  xloop, yloop  : integer;
  TmpStr      : string;
  EndStr      : string;
begin
  LogFunc := DoLog;
  // Initialise the connection
  StatusBar1.SimpleText := 'Connecting to player ...';
  Application.ProcessMessages;
  if InitPlayer2 <> $0055 then
  begin
    Application.MessageBox('Unable to connect to player. Please make sure the NEX is turned on and connected',
      'NEXNix error', MB_OK);
    Application.Terminate;
    exit;
  end;
  PlayerCmd1(0);
  InitPlayer2;
  PlayerCmd1(0);

  // Download the list of files
  FillFileTable(PlayerFiles);
  for FileLoop := 0 to MAXSONGS - 1 do
  begin
    if PlayerFiles[FileLoop].SongNumber <> $00FF then
    begin
      NewItem := PlayerFileView.Items.Add;
      NewItem.Caption := PlayerFiles[FileLoop].FileName;
      NewItem.SubItems.Add(PlayerFiles[FileLoop].SongTitle);
      NewItem.SubItems.Add(PlayerFiles[FileLoop].SongArtist);
      Bitrate := GetBitrate(PlayerFiles[FileLoop]);
      NumSeconds := PlayerFiles[FileLoop].Filesize div (Bitrate div 8);

      NewItem.SubItems.Add(SecondsToStr(PlayerFiles[FileLoop].Duration));
      NewItem.SubItems.Add(IntToStr(Bitrate div 1024));
      NewItem.SubItems.Add(IntToStr(PlayerFiles[FileLoop].Filesize));
      NewItem.SubItems.Add(NEXDateToStr(PlayerFiles[FileLoop]));


      ReadFlashRam(0, 64*(PlayerFiles[FileLoop].BlockStart), $210, @TmpBuf);

      for YLoop := 0 to ($210 div 16) - 1 do
      begin
        TmpStr := '';
        EndStr := '';
        for XLoop := 0 to 16 do
        begin
          if (TmpBuf[YLoop*16+XLoop] >= 32) and (TmpBuf[YLoop*16+XLoop] < 128)  then
            EndStr := EndStr + char(TmpBuf[YLoop*16+XLoop])
          else
            EndStr := EndStr + ' ';
          TmpStr := TmpStr + IntToHex(TmpBuf[YLoop*16+XLoop], 2) + ' ';
        end;
        Memo1.Lines.Add(TmpStr + ' | ' + EndStr);
      end;
      Memo1.Lines.Add('');
    end;
  end;
end;

end.
